#include <math.h>
#include "psg.h"

#define ONE FIXED (1)
#define PI FIXED (M_PI)

INLINE FIXED_TYPE env_wave_00XX(FIXED_TYPE in)
{
  if(in < PI)
    return ONE - DIV (in, PI);
  else 
    return 0;
}

INLINE FIXED_TYPE env_wave_01XX(FIXED_TYPE in)
{
  if(in < PI)
    return DIV (in, PI);
  else
    return 0;
}

INLINE FIXED_TYPE env_wave_1000(FIXED_TYPE in)
{
  return ONE - DIV (MOD (in, PI), PI);
}

INLINE FIXED_TYPE env_wave_1001(FIXED_TYPE in)
{
  if(in < PI)
    return ONE - DIV (in, PI);
  else 
    return 0;
}

INLINE FIXED_TYPE env_wave_1010(FIXED_TYPE in)
{
  FIXED_TYPE tmp;
  tmp = MOD (in, PI*2);
  if(tmp < PI)
    return ONE - DIV (tmp, PI);
  else
    return DIV (tmp - PI, PI);
}

INLINE FIXED_TYPE env_wave_1011(FIXED_TYPE in)
{
  if(in < PI)
    return ONE - DIV (in, PI);
  else
    return ONE;
}

INLINE FIXED_TYPE env_wave_1100(FIXED_TYPE in)
{
  return DIV (MOD (in, PI), PI);
}

INLINE FIXED_TYPE env_wave_1101(FIXED_TYPE in)
{
  if(in < PI)
    return DIV (in, PI);
  else
    return ONE;
}

INLINE FIXED_TYPE env_wave_1110(FIXED_TYPE in)
{
  FIXED_TYPE tmp;
  tmp = MOD (in, PI*2);
  if(tmp < PI)
    return DIV (tmp, PI);
  else
    return ONE - DIV (tmp - PI, PI);
}

INLINE FIXED_TYPE env_wave_1111(FIXED_TYPE in)
{
  if(in < PI)
    return DIV (in, PI);
  else
    return ONE;
}

FIXED_TYPE env_wave(FIXED_TYPE in, int mode)
{
  switch(mode) {
  case 0:
  case 1:
  case 2:
  case 3:
    return env_wave_00XX(in);
    break;
  case 4:
  case 5:
  case 6:
  case 7:
    return env_wave_01XX(in);
    break;
  case 8:
    return env_wave_1000(in);
    break;
  case 9:
    return env_wave_1001(in);
    break;
  case 10:
    return env_wave_1010(in);
    break;
  case 11:
    return env_wave_1011(in);
    break;
  case 12:
    return env_wave_1100(in);
    break;
  case 13:
    return env_wave_1101(in);
    break;
  case 14:
    return env_wave_1110(in);
    break;
  case 15:
    return env_wave_1111(in);
    break;
  }
  return 0;
}
